

clearvars
%  load('west0479');
% A=west0479;
load convdiff;
n=size(A,1);
nrwanted=10;
% eigsop.tol=[];
eigsop.v0=ones(n,1);
eigsop.p=nrwanted+15;
%% größte EW
[Rv,Rw]=eigs(A,nrwanted,'LM',eigsop);

fprintf('eigen residuen: %2.1e\n',norm(A*Rv-Rv*Rw))

%% kleinste EW (invert)
[Rv_s,Rw_s]=eigs(A,nrwanted,'SM',eigsop);

fprintf('eigen residuen: %2.1e\n',norm(A*Rv_s-Rv_s*Rw_s))

%% EW nahe Ziel (shift&invert)
tau=-500;
[Rv_z,Rw_z]=eigs(A,nrwanted,tau,eigsop);

fprintf('eigen residuen: %2.1e\n',norm(A*Rv_z-Rv_z*Rw_z))

%% EW nahe Ziel (shift&invert inexact) 
% mit vorkond. GMRES
inner_tol=1e-8;
inner_max=100;
L=[];U=[];

[L,U]=ilu(A-tau*speye(n),struct('droptol',1e-3,'type','ilutp'));
Afun=@(x) gmres(A-tau*speye(n),x,[],inner_tol,inner_max,L,U);

[Rv_i,Rw_i]=eigs(Afun,n,nrwanted,tau,eigsop);

fprintf('eigen residuen: %2.1e\n',norm(A*Rv_i-Rv_i*Rw_i))